# Utilities API

This page documents utility functions and helper classes used throughout the quantum data embedding suite.

## Data Validation and Preprocessing

### validate_data

::: quantum_data_embedding_suite.utils.validate_data
    options:
      show_source: true
      show_root_heading: true
      show_object_full_path: false

### normalize_data

::: quantum_data_embedding_suite.utils.normalize_data
    options:
      show_source: true
      show_root_heading: true
      show_object_full_path: false

### pad_features

::: quantum_data_embedding_suite.utils.pad_features
    options:
      show_source: true
      show_root_heading: true
      show_object_full_path: false

### reduce_features

::: quantum_data_embedding_suite.utils.reduce_features
    options:
      show_source: true
      show_root_heading: true
      show_object_full_path: false

## Data Generation and Analysis

### generate_random_data

::: quantum_data_embedding_suite.utils.generate_random_data
    options:
      show_source: true
      show_root_heading: true
      show_object_full_path: false

### compute_pairwise_distances

::: quantum_data_embedding_suite.utils.compute_pairwise_distances
    options:
      show_source: true
      show_root_heading: true
      show_object_full_path: false

### compute_data_statistics

::: quantum_data_embedding_suite.utils.compute_data_statistics
    options:
      show_source: true
      show_root_heading: true
      show_object_full_path: false

### estimate_optimal_qubits

::: quantum_data_embedding_suite.utils.estimate_optimal_qubits
    options:
      show_source: true
      show_root_heading: true
      show_object_full_path: false

### check_quantum_advantage_potential

::: quantum_data_embedding_suite.utils.check_quantum_advantage_potential
    options:
      show_source: true
      show_root_heading: true
      show_object_full_path: false

## Visualization Functions

These visualization functions are available in the `visualization` module:

### plot_kernel_comparison

::: quantum_data_embedding_suite.visualization.plot_kernel_comparison
    options:
      show_source: true
      show_root_heading: true
      show_object_full_path: false

### plot_expressibility_analysis

::: quantum_data_embedding_suite.visualization.plot_expressibility_analysis
    options:
      show_source: true
      show_root_heading: true
      show_object_full_path: false

### plot_kernel_eigenspectrum

::: quantum_data_embedding_suite.visualization.plot_kernel_eigenspectrum
    options:
      show_source: true
      show_root_heading: true
      show_object_full_path: false

### plot_embedding_landscape

::: quantum_data_embedding_suite.visualization.plot_embedding_landscape
    options:
      show_source: true
      show_root_heading: true
      show_object_full_path: false

### plot_gradient_analysis

::: quantum_data_embedding_suite.visualization.plot_gradient_analysis
    options:
      show_source: true
      show_root_heading: true
      show_object_full_path: false

### plot_kernel_alignment_heatmap

::: quantum_data_embedding_suite.visualization.plot_kernel_alignment_heatmap
    options:
      show_source: true
      show_root_heading: true
      show_object_full_path: false

### create_embedding_dashboard

::: quantum_data_embedding_suite.visualization.create_embedding_dashboard
    options:
      show_source: true
      show_root_heading: true
      show_object_full_path: false

### create_interactive_kernel_plot

::: quantum_data_embedding_suite.visualization.create_interactive_kernel_plot
    options:
      show_source: true
      show_root_heading: true
      show_object_full_path: false
